// UseAtlTrigDlg.cpp : implementation file

#include "stdafx.h"
#include "UseAtlTrig.h"
#include "UseAtlTrigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CUseAtlTrigDlg dialog
CUseAtlTrigDlg::CUseAtlTrigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUseAtlTrigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUseAtlTrigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	m_pTrig = 0;
}

void CUseAtlTrigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUseAtlTrigDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUseAtlTrigDlg, CDialog)
	//{{AFX_MSG_MAP(CUseAtlTrigDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ATL, OnButtonAtl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CUseAtlTrigDlg message handlers
BOOL CUseAtlTrigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUseAtlTrigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CUseAtlTrigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUseAtlTrigDlg::OnButtonAtl() 
{
	CString s;
	double x = 1.0, r;

	try
	{
		// Obtain an interface, but only once.
		if (0 == m_pTrig)
			m_pTrig = ItrigPtr(CLSID_trig);

		m_pTrig->ATLsin(x, &r);
		s.Format("The sin of %3.1lf is %lf", x, r);
		MessageBox(s);
	}	

	catch (_com_error &ex)
	{
		_bstr_t bstrSource(ex.Source());
		_bstr_t bstrDescription(ex.Description());
		char szTemp[1024];
		CString csMsg = "Oops - hit an error!\n";
		wsprintf(szTemp, "Code = %08lx\n", ex.Error());
		csMsg += szTemp;
		wsprintf(szTemp, "Code meaning = %s\n", ex.ErrorMessage());
		csMsg += szTemp;
		wsprintf(szTemp, "Source = %S\n", (wchar_t*)bstrSource);
		csMsg += szTemp;
		wsprintf(szTemp, "Description = %S\n", (wchar_t*)bstrDescription);
		csMsg += szTemp;
		MessageBox (csMsg);
		SysFreeString(bstrSource);
		SysFreeString(bstrDescription);
	}
}
